<?php require_once('digital.php'); ?>
<?php
if (!empty($_POST['action'])) {

    $limit = 25;
    switch ($_POST['action']) {
        case 'create':
            $digital = new digital($_POST['apikey'], $_POST['domain']);
            $info = $digital->account_info();

            //check account status
            if (isset($info['code']) && !$info['code'] == 200) {
                die(json_encode(['status' => FALSE, 'data' => $info['message']]));
            } elseif (isset($info['account']) && $info['account']['status'] == 'locked') {
                die(json_encode(['status' => FALSE, 'data' => $info['account']['status_message']]));
            }

            $region = $digital->get_regions();

            if (!$region['status']) {
                if (isset($region['result']['message'])) {
                    die(json_encode(['status' => FALSE, 'data' => $region['result']['message']]));
                } else {
                    die(json_encode(['status' => FALSE, 'data' => json_encode($region['result'])]));
                }
            }

            $nbDroplet = count($digital->get_droplets()['droplets']);
            $limitLeft = $limit - $nbDroplet;

            if ($limitLeft <= 0) {
                die(json_encode(['status' => FALSE, 'data' => 'Limit exist in this digital account '.$limit]));
            }

            $ssh = $digital->get_keys();
            $region = $region['result'];
            $result = [];
            if (count($ssh['ssh_keys']) > 0) {
                $ssh = [$ssh['ssh_keys'][0]['id']];
                for ($i = 0; $i < $limitLeft; $i++) {
                    $selectedRegion = $region[array_rand($region)];
                    $sub = 'digital' . rand(0, 1000);
                    $data = $digital->create_droplet($sub, $selectedRegion, $ssh);
                    $data['region'] = $selectedRegion;
                    $result[] = $data;
                }

                die(json_encode(['status' => TRUE, 'data' => $result]));
            } else {
                die(json_encode(['status' => FALSE, 'data' => 'SSH KEY NOT FOUND IN THIS ACCOUNT']));
            }

            break;

        case 'get':
            $digital = new digital($_POST['apikey']);
            $data = $digital->get_droplets();
            if ($data['code'] == 200) {
                die(json_encode(['status' => TRUE, 'data' => $data]));
            } else {
                die(json_encode(['status' => FALSE, 'data' => 'ERROR CHECK YOUR ACCOUNT']));
            }
            break;
        case 'delete':
            $digital = new digital($_POST['apikey']);
            $result = $digital->delete_droplet($_POST['id']);
            die(json_encode(['status' => TRUE, 'data' => $result]));
            break;
          case 'bulk_delete':
            if(!is_array($_POST['ids']))
            {
              die(json_encode(['status' => FALSE, 'data' => 'Select at Least one server']));
            }
            $digital = new digital($_POST['apikey']);
            foreach ($_POST['ids'] as $value) {
              $result [] = $digital->delete_droplet($value);
            }
            die(json_encode(['status' => TRUE, 'data' => $result ]));
          break;
        case 'reboot':
            $digital = new digital($_POST['apikey']);
            $result = $digital->action_droplet($_POST['id']);
            die(json_encode(['status' => TRUE, 'data' => $result]));
            break;
        case 'reinstall':
            $digital = new digital($_POST['apikey']);
            $result = $digital->action_droplet($_POST['id'], 'rebuild');
            die(json_encode(['status' => TRUE, 'data' => $result]));
            break;
        case 'rename':
            $digital = new digital($_POST['apikey']);
            $result = $digital->action_droplet($_POST['id'], 'rename', $_POST['domain']);
            die(json_encode(['status' => TRUE, 'data' => $result]));
        break;
        case 'reset_pass' :

        	include('Net/SFTP.php');
			include('Crypt/RSA.php');

			$ssh = new Net_SFTP($_POST['ip']);
			$key = new Crypt_RSA();
			$key->setPassword('test');
			$key->loadKey(file_get_contents(__DIR__.'/private.txt'));

			if (!$ssh->login('root', $key)) {
			   die(json_encode(['status' => FALSE, 'data' => 'COULDNT CONNECT']));
			}

            $ssh->exec("sudo su root");
            $ssh->exec("sudo sed -i 's/#Port 22/Port 22/g' /etc/ssh/sshd_config");
            $ssh->exec("sudo sed -i 's/PasswordAuthentication no/PasswordAuthentication yes/g' /etc/ssh/sshd_config");
            $ssh->exec("sudo sed -i 's/#PermitRootLogin yes/PermitRootLogin yes/g' /etc/ssh/sshd_config");
            $ssh->exec("sudo sed -i 's/PermitRootLogin without-password/#PermitRootLogin without-password/g' /etc/ssh/sshd_config");
            $ssh->exec("echo root:123456tanger | chpasswd");
            $ssh->exec("sudo service sshd restart");
            die(json_encode(['status' => TRUE, 'data' => 'OK PASSWORD CHANGED']));


            break;
            case 'bulk_reset':
              if(!is_array($_POST['ips']))
              {
                die(json_encode(['status' => FALSE, 'data' => 'Select at least one server']));
              }
              include('Net/SFTP.php');
              include('Crypt/RSA.php');

              $key = new Crypt_RSA();
              $key->setPassword('test');
              $key->loadKey(file_get_contents(__DIR__.'/private.txt'));

              foreach ($_POST['ips'] as $value) {
                $ssh = new Net_SFTP($value);
                if (!$ssh->login('root', $key)) {
                   $result[] = 'COULDNT CONNECT USING USER ROOT '.$value;
                } else {

                  $ssh->exec("sudo su root");
                  $ssh->exec("sudo sed -i 's/#Port 22/Port 22/g' /etc/ssh/sshd_config");
                  $ssh->exec("sudo sed -i 's/PasswordAuthentication no/PasswordAuthentication yes/g' /etc/ssh/sshd_config");
                  $ssh->exec("sudo sed -i 's/#PermitRootLogin yes/PermitRootLogin yes/g' /etc/ssh/sshd_config");
                  $ssh->exec("sudo sed -i 's/PermitRootLogin without-password/#PermitRootLogin without-password/g' /etc/ssh/sshd_config");
                  $ssh->exec("echo root:123456tanger | chpasswd");
                  $ssh->exec("sudo service sshd restart");

                  $result [] = 'password reseted '.$value;
                  unset($ssh);
                }

              }
              die(json_encode(['status' => TRUE, 'data' => $result ]));


            break;
        case 'test':

        	include('Net/SFTP.php');
			include('Crypt/RSA.php');

        	$ssh = new Net_SFTP($_POST['ip']);
			$key = new Crypt_RSA();
			$key->setPassword('test');
			$key->loadKey(file_get_contents(__DIR__.'/private.txt'));

			if (!$ssh->login('root', $key)) {
			   die(json_encode(['status' => FALSE, 'data' => 'COULDNT CONNECT']));
			}

			$cmd = "yum install -y mailx; echo \"hello world\" | mail -s \"TEST EMAIL\" {$_POST['email']};";
			$ssh->exec($cmd);
            die(json_encode(['status' => TRUE, 'data' => 'EMAIL SENDED']));

            break;

        case 'bulk_test':
            if(!is_array($_POST['ips']))
            {
              die(json_encode(['status' => FALSE, 'data' => 'Select at Least one server']));
            }
            include('Net/SFTP.php');
            include('Crypt/RSA.php');
            $key = new Crypt_RSA();
            $key->setPassword('test');
            $key->loadKey(file_get_contents(__DIR__.'/private.txt'));

            foreach ($_POST['ips'] as $value) {
              $ssh = new Net_SFTP($value);
              if (!$ssh->login('root', $key)) {
                $result [] = 'COULDNT CONNECT USING USER ROOT '.$value;
              } else {
                $cmd = "yum install -y mailx; echo \"hello world\" | mail -s \"TEST EMAIL\" {$_POST['email']};";
                $ssh->exec($cmd);
                $result [] = 'EMAIL SENDED '.$value;
              }
              unset($ssh);
            }
            die(json_encode(['status' => TRUE, 'data' => $result ]));
            break;
    }

    exit;
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
    <title>PROVIDERS</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="icon" href="./favicon.png">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.2.1/css/bootstrap.min.css">
    <link rel="stylesheet" type="text/css"
          href="https://cdn.datatables.net/v/bs4/dt-1.10.18/b-1.5.6/b-html5-1.5.6/r-2.2.2/datatables.min.css"/>
          <link rel="stylesheet" href="https://cdn.datatables.net/select/1.3.0/css/select.dataTables.min.css">

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.6/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.2.1/js/bootstrap.min.js"></script>
    <script type="text/javascript"
            src="https://cdn.datatables.net/v/bs4/dt-1.10.18/b-1.5.6/b-html5-1.5.6/r-2.2.2/datatables.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/sweetalert2@8.8.7/dist/sweetalert2.all.min.js"></script>
    <script type="text/javascript" src="https://cdn.datatables.net/select/1.3.0/js/dataTables.select.min.js"></script>
    <style>
        /* Show it is fixed to the top */
        body {
            min-height: 75rem;
            padding-top: 4.5rem;
        }
    </style>
</head>
<body>
<nav class="navbar navbar-expand-md navbar-dark fixed-top bg-dark">
    <a class="navbar-brand" href="#">PROVIDERS</a>
    <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarCollapse"
            aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarCollapse">
        <ul class="navbar-nav mr-auto">
            <li class="nav-item active">
                <a class="nav-link" href="./index.php">Digital Ocean</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="./scale.php">Scaleway</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" href="./cloud.php">Cloudcone</a>
            </li>
             <li class="nav-item">
                <a class="nav-link" href="./lin.php">Linode</a>
            </li>
        </ul>

    </div>
</nav>

<div class="container-fluid" style="margin-top: 30px">
    <div class="row">
        <div class="col-sm-12 col-md-6 offset-md-3">
            <h4>DIGITAL OCEAN</h4>
            <div class="form-group">
                <label for="#apikey">API KEY :</label>
                <input type="text" id="apikey" class="form-control"/>
            </div>
            <div class="form-group">
                <label for="#domain">Domain :</label>
                <input type="text" id="domain" class="form-control"/>
            </div>
            <div class="form-group">
                <label for="#nbservers">Number Servers :</label>
                <input type="text" id="nbservers" class="form-control"/>
            </div>
            <div class="form-group">
                <button id="create" class="btn btn-primary">CREATE</button>
                <button id="get" class="btn btn-secondary">GET</button>
            </div>
        </div>
    </div>
    <div class="row" id="result">
        <div class="col-sm-12">
            <h4>Total Servers <span id="total">0</span></h4>
            <div class="table-responsive">
                <table id="Table1" class="table table-sm table-hover table-striped" style="width:100%">

                </table>
            </div>
        </div>
    </div>
</div>
<script>
    const spinner = "<span class=\"spinner-border spinner-border-sm\" role=\"status\" aria-hidden=\"true\"></span>";
    $('#result').hide();
    $("#create").click(function (e) {
        e.preventDefault();

        if(!confirm("Are You Sure ?"))
        {
          return;
        }

        let api = $("#apikey").val();
        let domain = $("#domain").val() || 'domain.com';
        let nb = $("#nbservers").val() || 10;

        if (api && domain && nb) {
            let btn = this;
            $(btn).attr('disabled', true);
            $(btn).html("CREATING " + spinner);

            $.ajax({
                type: 'post',
                dataType: 'json',
                data: {
                    action: 'create',
                    apikey: api,
                    domain: domain,
                    nbservers: nb
                }
            }).done(function (e) {
                if (e.status) {
                    Swal.fire({
                        type: 'success',
                        title: 'Done',
                        text: 'Servers Created'
                    })
                } else {
                    Swal.fire({
                        type: 'error',
                        title: 'Oops',
                        text: e.data
                    })
                }
            }).always(function () {
                $(btn).attr('disabled', false);
                $(btn).html("CREATE");
            });
        } else {
            Swal.fire({
                type: 'error',
                title: 'Oops',
                text: 'Fill all data'

            });
        }
    });

    //get droplets
    $("#get").click(function (e) {
        e.preventDefault();
        let api = $("#apikey").val();
        if (api) {

            if ($.fn.DataTable.isDataTable("#Table1")) {
                $("#Table1").DataTable().destroy();
                $("#Table1").html("");
                $("#result").hide(1000);
            }

            let btn = this;
            $(btn).attr('disabled', true);
            $(btn).html("GETTING " + spinner);


            $.ajax({
                type: 'post',
                dataType: 'json',
                data: {
                    action: 'get',
                    apikey: api
                }
            }).done(function (e) {
                if (e.status) {
                    $("#result").show(1000);
                    $("#total").html(e.data.meta.total);
                    $buttons = [
                        {
                            text: 'Select all',
                            action: function(e, dt, node, config){
                                dt.rows().select();
                            },
                            className: "btn-sm btn-primary",
                        },
                        {
                            text: 'Select none',
                            action:  function(e, dt, node, config){
                                dt.rows().deselect();
                            },
                            className: "btn-sm btn-danger",
                        },
                        {
                            extend: "csv",
                            text: "export to csv",
                            header: false,
                            fieldBoundary: "",
                            fieldSeparator: ",",
                            filename: `Servers_${(new Date().getTime()).toString(16)}`,
                            extension: ".txt",
                            exportOptions: {
                                columns: [2],
                                format: {

                                    body: function (data, row, column, node) {
                                        return `${data},123456tanger`;
                                    }
                                }
                            },
                            className: "btn-sm btn-info",
                        },
                        {
                          text : "Delete",
                          className : "btn-sm btn-danger",
                          action : function(e, dt, node, config){
                             const count = dt.rows( { selected: true } ).count();
                             if(count > 0)
                             {
                               const data = dt.rows({selected:true}).data();
                               $(node).attr("disabled", true);
                               $(node).html("Deleting "+spinner);
                               const ids = $.map(data, function(i){
                                 return i["id"];
                               });
                               console.log(ids);
                               $.ajax({
                                 type : "post",
                                 dataType : "json",
                                 data : {
                                   action : "bulk_delete",
                                   ids : ids,
                                   apikey :$("#apikey").val()
                                 }
                               }).done(function(res){
                                 Swal.fire({
                                   type : res.status ? "success" : "error",
                                   title : res.status ? "Done" : "Oops",
                                   html : res.status ? "Servers Deleted" : ":("
                                 }).then((result) => {
                                   if(res.status){
                                     dt.rows({selected : true}).remove().draw();
                                     $("#total").html(dt.rows().count());
                                  }
                                 });

                               }).always(function(res){
                                 $(node).attr("disabled", false);
                                 $(node).html("Delete");
                               });

                             }
                             else {
                               Swal.fire({
                                   type: 'warning',
                                   title: 'Uh oh!',
                                   text: 'Select at least one server'
                               });
                             }

                          }
                        },
                        {
                          text : "Reset Passwords",
                          className : "btn-sm btn-info",
                          action : function(e, dt, node, config){
                            const count = dt.rows( { selected: true } ).count();
                            if(count > 0)
                            {
                              const data = dt.rows({selected:true}).data();
                              $(node).attr("disabled", true);
                              $(node).html("Reseting "+spinner);
                              const ips = $.map(data, function(i){
                                return i["networks"]["v4"][0]["ip_address"];
                              });
                              console.log(ips);
                              $.ajax({
                                type : "post",
                                dataType : "json",
                                data : {
                                  action : "bulk_reset",
                                  ips : ips,
                                }
                              }).done(function(res){
                                let result = "";
                                if(res.status){
                                  $.each(res.data, function(i,v){
                                    result += v +"<br>";
                                  });
                                }
                                Swal.fire({
                                  type : res.status ? "success" : "error",
                                  title : res.status ? "Done" : "Oops",
                                  text : res.data
                                });

                              }).always(function(res){
                                $(node).attr("disabled", false);
                                $(node).html("Reset Passwords");
                              });

                            }
                            else {
                              Swal.fire({
                                  type: 'warning',
                                  title: 'Uh oh!',
                                  text: 'Select at least one server'
                              });
                            }

                         }
                        },
                        {
                          text : "Test Email",
                          className : "btn-sm btn-success",
                          action : function(e, dt, node, config){
                            const count = dt.rows( { selected: true } ).count();
                            if(count > 0)
                            {
                              const email = prompt("Enter Your Email");
                              if(!email)
                              {
                                Swal.fire({
                                    type: 'warning',
                                    title: 'Uh oh!',
                                    text: 'Your must enter an email'
                                });

                                return;
                              }
                              const data = dt.rows({selected:true}).data();
                              $(node).attr("disabled", true);
                              $(node).html("Sending ... "+spinner);
                              const ips = $.map(data, function(i){
                                return i["networks"]["v4"][0]["ip_address"];
                              });
                              console.log(ips);
                              $.ajax({
                                type : "post",
                                dataType : "json",
                                data : {
                                  action : "bulk_test",
                                  ips : ips,
                                  email : email
                                }
                              }).done(function(res){
                                let result = "";
                                if(res.status){
                                  $.each(res.data, function(i,v){
                                    result += v +"<br>";
                                  });
                                }
                                Swal.fire({
                                  type : res.status ? "success" : "error",
                                  title : res.status ? "Done" : "Oops",
                                  html : res.status ? result : ":("
                                });

                              }).always(function(res){
                                $(node).attr("disabled", false);
                                $(node).html("Test Email");
                              });

                            }
                            else {
                              Swal.fire({
                                  type: 'warning',
                                  title: 'Uh oh!',
                                  text: 'Select at least one server'
                              });
                            }
                          }
                        }
                    ];
                    $columns = [
                        {title: "ID", data: "id", className: "text-center"},
                        {title: "hostname", data: "name", className: "text-center"},
                        {title: "ip", data: "networks.v4[0].ip_address", className: "text-center"},
                        {title: "created at", data: "created_at", className: "text-center"},
                        {title: "Region", data: "region.name", className: "text-center"},
                        {title: "Status", data: "status", className: "text-center"},
                        {
                            title: "Actions", render: function (data, type, row) {
                                var emailtest = `<button class="btn btn-sm btn-success" type="button" data-ip="${row["networks"]["v4"][0]["ip_address"]}" onclick="actions(this,'test');">TEST EMAIL</button>&nbsp;`
                                var resetpass = `<button class="btn btn-sm btn-info" type="button" data-ip="${row["networks"]["v4"][0]["ip_address"]}" onclick="actions(this,'resetpass');">RESET PASS</button>&nbsp;`
                                var btndelete = `<button class="btn btn-sm btn-danger" type="button" data-id="${row["id"]}" onclick="actions(this,'delete');">DELETE</button>&nbsp;`;
                                var rename = `<button class="btn btn-sm btn-dark" type="button" data-id="${row["id"]}" onclick="actions(this,'rename');">RENAME</button>&nbsp;`;
                                var reboot = `<button class="btn btn-sm btn-warning" type="button" data-id="${row["id"]}" onclick="actions(this,'reboot');">REBOOT</button>&nbsp;`;
                                var reinstall = `<button class="btn btn-sm btn-primary" type="button" data-id="${row["id"]}" onclick="actions(this,'reinstall');">REINSTALL</button>&nbsp;`;
                                return emailtest + resetpass + btndelete + reboot + rename +  reinstall;
                            }, className: "text-center", orderable: false
                        }
                    ];

                    if (e.data.meta.total > 0) {
                        $("#Table1").DataTable({
                            dom: "<'row'<'col-sm-5'B><'col-sm-2'><'col-sm-5'f>>" +
                                "<'row'<'col-sm-12'tr>>" +
                                "<'row'<'col-sm-5'i><'col-sm-7'p>>",
                            buttons: $buttons,
                            scrollCollapse: true,
                            Destroy: true,
                            //responsive: true,
                            paging: false,
                            order: [[0, "asc"]],
                            processing: true,
                            select :{
                              style : "multi"
                            },
                            data: e.data.droplets,
                            columns: $columns
                        });
                    } else {
                        Swal.fire({
                            type: 'info',
                            title: 'Done',
                            text: 'No Droplet Found'
                        });
                    }
                } else {
                    Swal.fire({
                        type: 'error',
                        title: 'Oops',
                        text: e.data
                    })
                }
            }).always(function () {
                $(btn).attr('disabled', false);
                $(btn).html("GET");
            });


        } else {
            Swal.fire({
                type: 'error',
                title: 'Oops',
                text: 'API KEY IS REQUIRED'

            });
        }
    });

    function actions(event, action){


        let api = $("#apikey").val();
        if(!api){
            Swal.fire({
                type: 'error',
                title: 'Oops',
                text: 'API KEY IS REQUIRED'

            });
            return;
        }
        switch(action){
            case 'delete' :
                if(confirm("ARE YOU SURE ?")){
                    $(event).attr("disabled", true);
                    $(event).html("DELETING "+spinner);

                    $.ajax({
                        type: 'post',
                        dataType: 'json',
                        data: {
                            action: 'delete',
                            apikey: api,
                            id : $(event).data("id")
                        }
                    }).done(function (e) {
                        if(e.data.code == 204)
                        {
                            $(event).closest ("tr").remove();
                            $("#total").text(parseInt($("#total").text())-1 || 0 ) ;
                            Swal.fire({
                                type : "success",
                                title : "Done",
                                text : "Server Deleted"
                            });
                        } else {
                            Swal.fire({
                                type : "error",
                                title : "Oops",
                                text : "Something happen"
                            });
                        }
                    });
                }
                break;
            case 'rename':
                let domain = prompt("Enter Your domain");
                console.log(domain);
                if(domain){
                    $(event).attr("disabled", true);
                    $(event).html("RENAMING "+spinner);

                    $.ajax({
                        type: 'post',
                        dataType: 'json',
                        data: {
                            action: 'rename',
                            apikey: api,
                            id : $(event).data("id"),
                            domain : domain
                        }
                    }).done(function (e) {

                        Swal.fire({
                            type : e.status ? "success" : "error",
                            title : e.status ? "Done" : "Oops...",
                            text : e.data.action.status
                        });

                    }).always(function () {
                        $(event).attr("disabled", false);//////.
                        $(event).html("RENAME");
                    });
                }
                break;
            case 'reboot' :
                if(confirm("ARE YOU SURE ?")){
                    $(event).attr("disabled", true);
                    $(event).html("REBOOTING "+spinner);

                    $.ajax({
                        type: 'post',
                        dataType: 'json',
                        data: {
                            action: 'reboot',
                            apikey: api,
                            id : $(event).data("id")
                        }
                    }).done(function (e) {

                        Swal.fire({
                            type : "success",
                            title : "Done",
                            text : e.data.action.type + " " +e.data.action.status
                        });

                    }).always(function () {
                        $(event).attr("disabled", false);
                        $(event).html("REBOOT");
                    });
                }
                break;
            case 'reinstall':
                if(confirm("ARE YOU SURE ?")){
                    $(event).attr("disabled", false);
                    $(event).html("REINSTALLING "+spinner);

                    $.ajax({
                        type: 'post',
                        dataType: 'json',
                        data: {
                            action: 'reinstall',
                            apikey: api,
                            id : $(event).data("id")
                        }
                    }).done(function (e) {

                        Swal.fire({
                            type : "success",
                            title : "Done",
                            text : e.data.action.type + " " +e.data.action.status
                        });

                    }).always(function () {
                        $(event).attr("disabled", false);
                        $(event).html("REINSTALL");
                    });
                }
                break;
            case 'resetpass':
                if(confirm("ARE YOU SURE ?")){
                    $(event).attr("disabled", true);
                    $(event).html("WORKING "+spinner);

                    $.ajax({
                        type: 'post',
                        dataType: 'json',
                        data: {
                            action: 'reset_pass',
                            ip: $(event).data("ip")
                        }
                    }).done(function (e) {

                        Swal.fire({
                            type : e.status ? "success" : "error",
                            title : e.status ? "Done" : "Oops...",
                            text : e.data
                        });

                    }).always(function () {
                        $(event).attr("disabled", false);
                        $(event).html("RESET PASS");
                    });
                }
                break;
            case 'test' :
                let email = prompt("Enter Your Email");
                console.log(email);
                if(email){
                    $(event).attr("disabled", true);
                    $(event).html("TESTING "+spinner);

                    $.ajax({
                        type: 'post',
                        dataType: 'json',
                        data: {
                            action: 'test',
                            ip: $(event).data("ip"),
                            email : email
                        }
                    }).done(function (e) {

                        Swal.fire({
                            type : e.status ? "success" : "error",
                            title : e.status ? "Done" : "Oops...",
                            text : e.data
                        });

                    }).always(function () {
                        $(event).attr("disabled", false);//////.
                        $(event).html("EMAIL TEST");
                    });
                }
                break;
            default :
                alert("unknow action");
        }
    }

    $(window).bind("resize", function () {
        $($.fn.dataTable.tables(true)).DataTable().columns.adjust().responsive.recalc();
    });
</script>
</body>
</html>
